import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long[] arr = new long[n];
        long sum = 0;
        for (int i = 0; i < n; i++) arr[i] = nextInt();
        for (int i = 0; i < n; i++) sum += arr[i];
        int q = nextInt();
        long moved = 0;
        for (int i = 0; i < q; i++) {
            int type = nextInt();
            if (type == 2) {
                moved+=nextInt();
                moved%=n;
            }else {
                int ind = (int) (nextInt()-moved-1);
                if (ind < 0) ind+=n;
                int x = nextInt();
                sum -= arr[ind];
                sum+=x;
                arr[ind] = x;
            }
            out.println(sum);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}