import java.io.*;
import java.util.*;
/*
4
4 2 2
4 4 4
6 5 5
8 13 17
     */
public class Main {
    public static void main(String[] args) throws IOException {
        int z = nextInt();
        TreeMap<O, Long> arr = new TreeMap<>();
        for (int i = 0; i < z; i++) {
            long n = nextLong();
            long a = nextLong();
            long b = nextLong();
            if (arr.containsKey(new O(n,a,b))) {
                out.println(arr.get(new O(n,a,b)));
                continue;
            }
            if (a > b) {
                long h = a;
                a = b;
                b = h;
            }
            long ans = -1;
            for (long j = 0; j <= a; j++) {
                ans += Math.max(0,b - (n*a-j)%n)/n+1;
                if (b-(n*a-j)%n < 0) ans--;
            }
            out.println(ans);
            arr.put(new O(n,a,b), ans);
        }
        out.close();
    }
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");
    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }
    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}
class O implements Comparable<O>{
    long a;
    long b;
    long c;
    public O(long a, long b, long c) {
        this.a = a;
        this.b = b;
        this.c = c;
    }

    @Override
    public int compareTo(O o) {
        if (o.a == a&& o.b == b && o.c == c) return 0;
        else return 1;
    }
}