import java.io.*;
import java.util.*;
public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int q = nextInt();
        int[] a = new int[n];
        int[] b = new int[n];
        for (int i = 0; i < n; i++) a[i] = nextInt();
        for (int i = 0; i < n; i++) b[i] = nextInt();
        O[] arr = new O[n*n];
        for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) arr[i*n+j] = new O(a[i],b[j]);
        Arrays.sort(arr);
        for (int i = 0; i < q; i++) {
            O ans = arr[nextInt()-1];
            out.println(ans.a+" "+ans.b);
        }
        out.close();
    }
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");
    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }
    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    public static int gcd(int a, int b) {
        if (a == 0 || b == 0) return Math.max(a,b);
        if (a > b) return gcd(a%b, b);
        return gcd(a,b%a);
    }
}
class O implements Comparable<O>{
    double d;
    int a;
    int b;
    public O(int a, int b) {
        this.a = a;
        this.b = b;
        int h = Main.gcd(a,b);
        this.a/=h;
        this.b/=h;
        this.d = (a*1.0)/(b*1.0);
    }

    @Override
    public int compareTo(O o) {
        return Double.compare(d, o.d);
    }
}