import java.io.*;
import java.util.*;
/*
4 8
3 4 1 2
2 3 4 5
1 16 2 4 5 6 10 15
 */
public class Main {
    static int[] b;
    static int[] a;
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int q = nextInt();
        a = new int[n];
        int[] b0 = new int[n];
        for (int i = 0; i < n; i++) a[i] = nextInt();
        for (int i = 0; i < n; i++) b0[i] = nextInt();
        if (n <= 500) {
            O[] arr = new O[n * n];
            for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) arr[i * n + j] = new O(a[i], b0[j]);
            Arrays.sort(arr);
            for (int i = 0; i < q; i++) {
                O ans = arr[nextInt() - 1];
                out.println(ans.a + " " + ans.b);
            }
        }else {
            Arrays.sort(a);
            Arrays.sort(b0);
            b = new int[n];
            for (int i = 0; i < n; i++) b[n-i-1] = b0[i];
            O2[] ans = new O2[Math.min(5000000, n*n)];
            int N = ans.length;
            PriorityQueue<O2> pq = new PriorityQueue<>();
            for (int i = 0; i < n; i++) pq.add(new O2(i+1, 1));
            for (int i = 0; i < N; i++) {
                O2 k = pq.poll();
                ans[i] = k;
                if (k.b+1 <= n) pq.add(new O2(k.a, k.b+1));
            }
            for (int i = 0; i < q; i++) {
                int k = nextInt();
                O2 ansO = ans[k-1];
                int aa = a[ansO.a-1];
                int bb = b[ansO.b-1];
                int h = gcd(aa,bb);
                out.println(aa/h+" "+bb/h);
            }
        }
        out.close();
    }
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");
    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }
    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    public static int gcd(int a, int b) {
        if (a == 0 || b == 0) return Math.max(a,b);
        if (a > b) return gcd(a%b, b);
        return gcd(a,b%a);
    }
}
class O implements Comparable<O>{
    double d;
    int a;
    int b;
    public O(int a, int b) {
        this.a = a;
        this.b = b;
        int h = Main.gcd(a,b);
        this.a/=h;
        this.b/=h;
        this.d = (a*1.0)/(b*1.0);
    }

    @Override
    public int compareTo(O o) {
        return Double.compare(d, o.d);
    }
}
class O2 implements Comparable<O2>{
    int a;
    int b;
    double d;
    public O2(int a2, int b2) {
        this.a = a2;
        this.b = b2;
        this.d = (Main.a[a2-1]*1.0)/(Main.b[b2-1]*1.0);
    }

    @Override
    public int compareTo(O2 o) {
        return Double.compare(d, o.d);
    }
}