import java.io.*;
import java.util.*;
public class Main {

    /*
4
4 2 2
4 4 4
6 5 5
8 13 17
     */
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int k = nextInt();
        int[] arr = new int[n];
        long ans = Long.MIN_VALUE;
        for (int i = 0; i < n; i++) arr[i] = nextInt();
        for (int i = 0; i < n; i++) {
            if (arr[i] < 0) continue;
            for (int j = i; j < n; j++) {
                if (arr[j] < 0) continue;
                long sum = 0;
                int[] arr2 = new int[j-i+1];
                for (int l = i; l <= j; l++) {
                    sum += arr[l];
                    arr2[l-i] = arr[l];
                }
                Arrays.sort(arr2);
                for (int l = arr2.length-1; l > Math.max(-1,arr2.length-1-k); l--) sum -= arr2[l];
                ans = Math.max(sum, ans);
            }
        }
        if (ans == Long.MIN_VALUE) ans = 0;
        out.println(ans);
        out.close();
    }
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");
    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }
    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}