import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int f = nextInt();
        long[] arr = new long[n];
        long maxd = -1;
        if (f == 1) {
            for (int i = 0; i < n; i++) {
                arr[i] = nextInt();
            }
        }else {
            int m = nextInt();
            long x = nextLong();
            long y = nextLong();
            long z = nextLong();
            for (int i = 0; i < n; i++) {
                if (i+1 <= m)arr[i] = nextInt();
                else arr[i] = ((x*arr[i-2]+y*arr[i-1]+z)%1000000000)+1;
            }
        }
        ArrayList<Long> plases = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            if (arr[i] > maxd) {
                maxd = arr[i];
                plases = new ArrayList<>();
                plases.add((long) i);
            } else if (arr[i] == maxd) plases.add((long) i);
        }
        long bp = plases.get(plases.size() - 1);
        long bdist = n - plases.get(plases.size() - 1) + plases.get(0);
        for (int i = 0; i < plases.size() - 1; i++) {
            if (plases.get(i + 1) - plases.get(i) > bdist) {
                bp = i;
                bdist = plases.get(i + 1) - plases.get(i);
            }
        }
        long ans = 1;
        for (long i = bp + 1; i < n; i++) {
            ans = Math.max(ans, arr[(int) i] - (i - bp - 1));
        }
        for (int i = 0; i <= bp; i++) {
            ans = Math.max(ans, arr[i] - (n - bp - 1 + i));
        }
        out.print(ans + " ");
        out.print(bp);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}